kate Library: KateNormalIndent Class Reference (kate Library)

| # kate Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KateNormalIndent Class Reference

Provides Auto-Indent functionality for katepart. More...

`#include <kateautoindent.h>`

Inheritance diagram for KateNormalIndent:

[legend]
Collaboration diagram for KateNormalIndent:

[legend]
List of all members.

## Public Member Functions
| KateNormalIndent (KateDocument *doc)
virtual | ~KateNormalIndent ()
virtual void | updateConfig ()
virtual bool | canProcessNewLine () const
virtual void | processNewline (KateDocCursor &cur, bool needContinue)
virtual void | processChar (QChar)
virtual void | processLine (KateDocCursor &)
virtual void | processSection (KateDocCursor &, KateDocCursor &)
virtual bool | canProcessLine () const
virtual uint | modeNumber () const
## Protected Member Functions
bool | isBalanced (KateDocCursor &begin, const KateDocCursor &end, QChar open, QChar close, uint &pos) const
bool | skipBlanks (KateDocCursor &cur, KateDocCursor &max, bool newline) const
uint | measureIndent (KateDocCursor &cur) const
QString | tabString (uint length) const
## Protected Attributes
uint | tabWidth
uint | indentWidth
uchar | commentAttrib
uchar | doxyCommentAttrib
uchar | regionAttrib
uchar | symbolAttrib
uchar | alertAttrib
uchar | tagAttrib
uchar | wordAttrib
uchar | keywordAttrib
uchar | normalAttrib
uchar | extensionAttrib
bool | useSpaces
bool | mixedIndent
bool | keepProfile

## Detailed Description

Provides Auto-Indent functionality for katepart.

Definition at line 161 of file kateautoindent.h.

## Constructor & Destructor Documentation

KateNormalIndent::KateNormalIndent | ( | KateDocument * | doc | ) |

  | Constructor. Parameters:
  | doc | parent document
Definition at line 156 of file kateautoindent.cpp.

KateNormalIndent::~KateNormalIndent | ( |  | ) | `[virtual]`

| Virtual Destructor for the baseclass. Definition at line 160 of file kateautoindent.cpp.

## Member Function Documentation

void KateNormalIndent::updateConfig | ( |  | ) | `[virtual]`

| Update indenter's configuration (indention width, attributes etc.). Reimplemented from KateAutoIndent. Definition at line 164 of file kateautoindent.cpp. References QPtrList::at(), QPtrList::count(), QString::find(), indentWidth, keepProfile, mixedIndent, tabWidth, and useSpaces. Referenced by KateVarIndent::processLine().

virtual bool KateNormalIndent::canProcessNewLine | ( |  | ) | const`[inline, virtual]`

| does this indenter support processNewLine Returns: can you do it? Reimplemented from KateAutoIndent. Definition at line 184 of file kateautoindent.h.

void KateNormalIndent::processNewline | ( | KateDocCursor & | cur,
|  | bool | needContinue
| ) | `[virtual]`

  | Called every time a newline character is inserted in the document. Parameters:
  | cur | The position to start processing. Contains the new cursor position after the indention.
  | needContinue | Used to determine whether to calculate a continue indent or not.
Reimplemented from KateAutoIndent. Reimplemented in KateVarIndent. Definition at line 344 of file kateautoindent.cpp. References QString::length().

virtual void KateNormalIndent::processChar | ( | QChar |  | ) | `[inline, virtual]`

  | Called every time a character is inserted into the document. Parameters:
  | c | character inserted
Reimplemented from KateAutoIndent. Reimplemented in KateVarIndent. Definition at line 198 of file kateautoindent.h.

virtual void KateNormalIndent::processLine | ( | KateDocCursor & |  | ) | `[inline, virtual]`

| Aligns/indents the given line to the proper indent position. Reimplemented from KateAutoIndent. Reimplemented in KateVarIndent. Definition at line 203 of file kateautoindent.h.

virtual void KateNormalIndent::processSection | ( | KateDocCursor & | ,
|  | KateDocCursor & |
| ) | `[inline, virtual]`

| Processes a section of text, indenting each line in between. Reimplemented from KateAutoIndent. Reimplemented in KateVarIndent. Definition at line 208 of file kateautoindent.h.

virtual bool KateNormalIndent::canProcessLine | ( |  | ) | const`[inline, virtual]`

| Set to true if an actual implementation of 'processLine' is present. This is used to prevent a needless Undo action from being created. Reimplemented from KateAutoIndent. Reimplemented in KateVarIndent. Definition at line 214 of file kateautoindent.h.

virtual uint KateNormalIndent::modeNumber | ( |  | ) | const`[inline, virtual]`

| Mode index of this mode. Returns: modeNumber Reimplemented from KateAutoIndent. Reimplemented in KateVarIndent. Definition at line 220 of file kateautoindent.h.

bool KateNormalIndent::isBalanced | ( | KateDocCursor & | begin,
|  | const KateDocCursor & | end,
|  | QChar | open,
|  | QChar | close,
|  | uint & | pos
| ) | const`[protected]`

  | Determines if the characters open and close are balanced between `begin` and `end` Fills in `pos` with the column position of first opened character if found. Parameters:
  | begin | Beginning cursor position.
  | end | Ending cursor position where the processing will stop.
  | open | The open character.
  | close | The closing character which should be matched against `open`.
  | pos | Contains the position of the first `open` character in the line.
Returns: True if `open` and `close` have an equal number of occurances between `begin` and `end`. False otherwise. Definition at line 234 of file kateautoindent.cpp. References QChar::isSpace(), and measureIndent().

bool KateNormalIndent::skipBlanks | ( | KateDocCursor & | cur,
|  | KateDocCursor & | max,
|  | bool | newline
| ) | const`[protected]`

  | Skip all whitespace starting at `cur` and ending at `max`. Spans lines if `newline` is set. `cur` is set to the current position afterwards. Parameters:
  | cur | The current cursor position to start from.
  | max | The furthest cursor position that will be used for processing
  | newline | Whether we are allowed to span multiple lines when skipping blanks
Returns: True if `cur` < `max` after processing. False otherwise. Definition at line 279 of file kateautoindent.cpp. References QChar::isNull(), and QChar::isSpace().

uint KateNormalIndent::measureIndent | ( | KateDocCursor & | cur | ) | const`[protected]`

  | Measures the indention of the current textline marked by cur. Parameters:
  | cur | The cursor position to measure the indent to.
Returns: The length of the indention in characters. Definition at line 315 of file kateautoindent.cpp. References mixedIndent, tabWidth, and useSpaces. Referenced by isBalanced().

QString KateNormalIndent::tabString | ( | uint | length | ) | const`[protected]`

  | Produces a string with the proper indentation characters for its length. Parameters:
  | length | The length of the indention in characters.
Returns: A QString representing `length` characters (factoring in tabs and spaces) Definition at line 323 of file kateautoindent.cpp. References mixedIndent, tabWidth, and useSpaces. Referenced by KateVarIndent::processLine().

## Member Data Documentation

uint KateNormalIndent::tabWidth`[protected]`

| The number of characters simulated for a tab. Definition at line 263 of file kateautoindent.h. Referenced by measureIndent(), tabString(), and updateConfig().

uint KateNormalIndent::indentWidth`[protected]`

| The number of characters used when tabs are replaced by spaces. Definition at line 264 of file kateautoindent.h. Referenced by updateConfig().

bool KateNormalIndent::useSpaces`[protected]`

| Should we use spaces or tabs to indent. Definition at line 278 of file kateautoindent.h. Referenced by measureIndent(), tabString(), and updateConfig().

bool KateNormalIndent::mixedIndent`[protected]`

| Optimize indent by mixing spaces and tabs, ala emacs. Definition at line 279 of file kateautoindent.h. Referenced by measureIndent(), tabString(), and updateConfig().

bool KateNormalIndent::keepProfile`[protected]`

| Always try to honor the leading whitespace of lines already in the file. Definition at line 280 of file kateautoindent.h. Referenced by updateConfig().

The documentation for this class was generated from the following files:

- kateautoindent.h
- kateautoindent.cpp

This file is part of the documentation for kate Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:36:49 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003